#ifndef _CONF_USB_H_
#define _CONF_USB_H_

#define dprintf(...)
//printf
#define debug_init()
//USART_Init
//#include <stdio.h>


#define GUITAR_NONE 0
#define GUITAR_GH3 1
#define GUITAR_RB 2

#define EE_APP_OK_ADDR 0x00


    //! When the application voltage is lower than 3.5V, to optimize power consumption
    //! the internal USB pads regulatr can be disabled.
    #define USE_USB_PADS_REGULATOR   ENABLE      // Possible values ENABLE or DISABLE


// megaUSB1287 & usb162
    #define DDR_SPI DDRB
    #define DD_MOSI 2
    #define DD_SCK 1
    #define DD_SS 0
    #define DD_MISO 3
    #define PORT_SS PORTB_Bit0


#ifdef DEVSIDE
    #define USB_HOST_FEATURE      DISABLE
    #define USB_DEVICE_FEATURE    ENABLE
    #define FOSC 8000



#endif

#ifndef DEVSIDE
    #define FOSC 8000
    #define USB_HOST_FEATURE      ENABLE
    #define USB_DEVICE_FEATURE    DISABLE

#endif

    #define USB_LOW_SPEED_DEVICE  DISABLE


#if (USB_HOST_FEATURE == ENABLED)
#define DEVICE_ADDRESS           0x05
#define SIZEOF_DATA_STAGE        250

   //! Host start of frame interrupt always enable
   #define HOST_CONTINUOUS_SOF_INTERRUPT  ENABLE
   //! USB host pipes transfers use USB communication interrupt (allows to use none blocking functions)
   #define USB_HOST_PIPE_INTERRUPT_TRANSFER  ENABLE
   #define MAX_INTERFACE_SUPPORTED 2
   //! Enable cpt NAK Timeout for host transfer
   #define NAK_TIMEOUT_ENABLE          ENABLE

   //! Number of NAK handshake before timeout for transmit functions (up to 0xFFFF)
   #define NAK_SEND_TIMEOUT            0x0010

   //! NAKNumber of NAK handshake before timeout for receive functions (up to 0xFFFF)
   #define NAK_RECEIVE_TIMEOUT         0x0010

//#define HOST_ERROR_RESTART ENABLE

#endif




#define NB_ENDPOINTS          3
#define NB_CONFIGURATION 1




#endif // _CONF_USB_H_

