#if (FOSC==16000)
    #define USART_BAUD 25
#elif (FOSC==8000)
    #define USART_BAUD 25 /2
#else
    #error only 8Mhz and 16Mhz supported
#endif


void USART_Init()
{
    /* Set baud rate */
    UBRR1 = USART_BAUD;
    /* Enable receiver and transmitter */
    UCSR1B = (1<<RXEN1)|(1<<TXEN1); //
    /* Set frame format: 8data, 2stop bit */
    UCSR1C = (3<<UCSZ10);
}    
int putchar( int outchar )
{
    /* Wait for empty transmit buffer */
    while ( !( UCSR1A & (1<<UDRE1)))  ;

    UDR1 = outchar&0xff;
    return outchar;
}
