#include "conf_usb.h"
#include "compiler.h"
#include "usb.h"
#include "usb_avr_registers.h"
#include "descriptors.h"


#if (USB_DEVICE_FEATURE == ENABLED)

S_usb_device_descriptor code * desc_dev_active = NULL;

code S_usb_device_descriptor desc_dev_rb =
{
  sizeof(S_usb_device_descriptor)
, DEVICE_DESCRIPTOR
, Usb_write_word_enum_struc(0x0110)
, NO_CLASS
, NO_SUBCLASS
, 0 //protocol
, EP_CONTROL_LENGTH
, Usb_write_word_enum_struc(VID_SONY)
, Usb_write_word_enum_struc(PID_RB)
, Usb_write_word_enum_struc(0x0313) // release number
, 1 // manuf string idx 
, 2 // product string idx
, 0 // serial string idx
, 1 // number of configs
};
code S_usb_device_descriptor desc_dev_gh3 =
{
  sizeof(S_usb_device_descriptor)
, DEVICE_DESCRIPTOR
, Usb_write_word_enum_struc(0x0100)
, NO_CLASS
, NO_SUBCLASS
, 0 //protocol
, EP_CONTROL_LENGTH
, Usb_write_word_enum_struc(VID_SONY)
, Usb_write_word_enum_struc(PID_GH3)
, Usb_write_word_enum_struc(0x108) // release number
, 1 // manuf string idx 
, 2 // product string idx
, 0 // serial string idx
, 1 // number of configs
};



code char descr_str_langid[] = "\x04\x03\x09\x04";
/*
code char descr_str_manuid_rb[] ="\x60\x03L\0i\0c\0e\0n\0s\0e\0d\0 \0b\0y\0 \0S\0o\0n\0y\0 \0C\0o\0m\0p\0u\0t\0e\0r\0 \0E\0n\0t\0e\0r\0t\0a\0i\0n\0m\0e\0n\0t\0 \0A\0m\0e\0r\0i\0c\0a\0";
code char descr_str_prodid_rb[] ="\x44\x03H\0a\0r\0m\0o\0n\0i\0x\0 \0G\0u\0i\0t\0a\0r\0 \0f\0o\0r\0 \0P\0l\0a\0y\0S\0t\0a\0t\0i\0o\0n\0\0003\0";

code char descr_str_manuid_gh3[] ="\x50\x03L\0i\0c\0e\0n\0s\0e\0d\0 \0b\0y\0 \0S\0o\0n\0y\0 \0C\0o\0m\0p\0u\0t\0e\0r\0 \0E\0n\0t\0e\0r\0t\0a\0i\0n\0m\0e\0n\0t\0";
code char descr_str_prodid_gh3[] ="\x46\x03G\0u\0i\0t\0a\0r\0 \0H\0e\0r\0o\0003\0 \0f\0o\0r\0 \0P\0l\0a\0y\0S\0t\0a\0t\0i\0o\0n\0 \0(\0R\0)\0 \0003\0"; 
*/
code char descr_str_manuid_rb[] ="\x60\x03L\0icensed by Sony Computer Entertainment America";
code char descr_str_prodid_rb[] ="\x44\x03H\0armonix Guitar for PlayStation3";

code char descr_str_manuid_gh3[] ="\x50\x03L\0icensed by Sony Computer Entertainment";
code char descr_str_prodid_gh3[] ="\x46\x03G\0uitar Hero3 for PlayStation (R) 3"; 


char code * desc_str_active[] = { 
    descr_str_langid,
    NULL,
    NULL,
};


S_usb_user_configuration_descriptor code * desc_conf_active = NULL;


U8 sony_hid_report[PS3_REPORT_SZ];

code U8 sony_hid_report_descriptor[137] = {
0x05, 0x01, 0x09, 0x05, 0xa1, 0x01, 0x15, 0x00,
0x25, 0x01, 0x35, 0x00, 0x45, 0x01, 0x75, 0x01,
0x95, 0x0d, 0x05, 0x09, 0x19, 0x01, 0x29, 0x0d,
0x81, 0x02, 0x95, 0x03, 0x81, 0x01, 0x05, 0x01,
0x25, 0x07, 0x46, 0x3b, 0x01, 0x75, 0x04, 0x95,
0x01, 0x65, 0x14, 0x09, 0x39, 0x81, 0x42, 0x65,
0x00, 0x95, 0x01, 0x81, 0x01, 0x26, 0xff, 0x00,
0x46, 0xff, 0x00, 0x09, 0x30, 0x09, 0x31, 0x09,
0x32, 0x09, 0x35, 0x75, 0x08, 0x95, 0x04, 0x81,
0x02, 0x06, 0x00, 0xff, 0x09, 0x20, 0x09, 0x21,
0x09, 0x22, 0x09, 0x23, 0x09, 0x24, 0x09, 0x25,
0x09, 0x26, 0x09, 0x27, 0x09, 0x28, 0x09, 0x29,
0x09, 0x2a, 0x09, 0x2b, 0x95, 0x0c, 0x81, 0x02,
0x0a, 0x21, 0x26, 0x95, 0x08, 0xb1, 0x02, 0x0a,
0x21, 0x26, 0x91, 0x02, 0x26, 0xff, 0x03, 0x46,
0xff, 0x03, 0x09, 0x2c, 0x09, 0x2d, 0x09, 0x2e,
0x09, 0x2f, 0x75, 0x10, 0x95, 0x04, 0x81, 0x02,
0xc0};

code S_usb_user_configuration_descriptor desc_conf_gh3 = {
 { sizeof(S_usb_configuration_descriptor)
 , CONFIGURATION_DESCRIPTOR
 , Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)
       +sizeof(S_usb_interface_descriptor)
       +sizeof(S_usb_hid_descriptor)
       +sizeof(S_usb_hid_specific_descriptor)
       +sizeof(S_usb_endpoint_descriptor)   
       +sizeof(S_usb_endpoint_descriptor)
           )  
 , 1 //NB_INTERFACE
 , 1 //CONF_NB
 , 0 //CONF_INDEX
 , USB_CONFIG_BUSPOWERED
 , 250
 }
 ,
 { sizeof(S_usb_interface_descriptor)
 , INTERFACE_DESCRIPTOR
 , 0 //INTERFACE_NB
 , 0 //ALTERNATE_TEMP
 , 2 //NB_ENDPOINT_TEMP
 , HID_CLASS //INTERFACE_CLASS_TEMP
 , NO_SUBCLASS //INTERFACE_SUB_CLASS_TEMP
 , 0 //INTERFACE_PROTOCOL_TEMP
 , 0 //INTERFACE_INDEX_TEMP
 }
 ,
 { sizeof(S_usb_hid_descriptor)+sizeof(S_usb_hid_specific_descriptor)
   ,HID_DESCRIPTOR
   ,0x0110           // bcdHID
   ,0               // country
   ,1               // number of specific descriptors
 },{HID_REPORT_DESCRIPTOR,0x89}
 ,
 { sizeof(S_usb_endpoint_descriptor)
 , ENDPOINT_DESCRIPTOR
 , GUITAR_EP_INT_IN
 , USB_EP_ATTRIBUTE_INT
 , Usb_write_word_enum_struc(64)//EP_SIZE_TEMP
 , 0x0a //EP_INTERVAL_TEMP1
 }
 ,
 { sizeof(S_usb_endpoint_descriptor)
 , ENDPOINT_DESCRIPTOR
 , GUITAR_EP_INT_OUT
 , USB_EP_ATTRIBUTE_INT
 , Usb_write_word_enum_struc(64)
 , 0x0a
 }
};
code S_usb_user_configuration_descriptor desc_conf_rb = {
 { sizeof(S_usb_configuration_descriptor)
 , CONFIGURATION_DESCRIPTOR
 , Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)
       +sizeof(S_usb_interface_descriptor)   
       +sizeof(S_usb_hid_descriptor)
       +sizeof(S_usb_hid_specific_descriptor)
       +sizeof(S_usb_endpoint_descriptor)   
       +sizeof(S_usb_endpoint_descriptor)
           )  
 , 1 //NB_INTERFACE
 , 1 //CONF_NB
 , 0 //CONF_INDEX
 , USB_CONFIG_BUSPOWERED
 , 250
 }
 ,
 { sizeof(S_usb_interface_descriptor)
 , INTERFACE_DESCRIPTOR
 , 0 //INTERFACE_NB
 , 0 //ALTERNATE_TEMP
 , 2 //NB_ENDPOINT_TEMP
 , HID_CLASS //INTERFACE_CLASS_TEMP
 , NO_SUBCLASS //INTERFACE_SUB_CLASS_TEMP
 , 0 //INTERFACE_PROTOCOL_TEMP
 , 0 //INTERFACE_INDEX_TEMP
 }
 ,
  { sizeof(S_usb_hid_descriptor)+sizeof(S_usb_hid_specific_descriptor)
   ,HID_DESCRIPTOR
   ,0x0101          // bcdHID
   ,0               // country
   ,1               // number of specific descriptors
 },{HID_REPORT_DESCRIPTOR,0x89}
 ,
 { sizeof(S_usb_endpoint_descriptor)
 , ENDPOINT_DESCRIPTOR
 , GUITAR_EP_INT_IN
 , USB_EP_ATTRIBUTE_INT
 , Usb_write_word_enum_struc(64)//EP_SIZE_TEMP
 , 0x0a //EP_INTERVAL_TEMP1
 }
 ,
 { sizeof(S_usb_endpoint_descriptor)
 , ENDPOINT_DESCRIPTOR
 , GUITAR_EP_INT_OUT
 , USB_EP_ATTRIBUTE_INT
 , Usb_write_word_enum_struc(64)
 , 0x0a
 }
};



#endif
