#define SPI_AS_SLAVE 0
#define SPI_AS_HOST 1

#define SPI_SlaveIsReady() (SPDR=0x00)
#define SPI_SlaveIsBusy() (SPDR=0xff)
#define SPI_WaitForComplete() while(!(SPSR & (1<<SPIF)))

#define SPI_RPC_MSG_MSG_OFS  0
#define SPI_RPC_MSG_MSG_MASK 0x7
#define SPI_RPC_MSG_NONE 0
#define SPI_RPC_MSG_SETDEVICE 1
#define SPI_RPC_MSG_SETREPORT 2

#define SPI_RPC_MSG_SZ_OFS  3
#define SPI_RPC_MSG_SZ_MASK 0x38

#define SPI_RPC_MSG_DATA_OFS  6
#define SPI_RPC_MSG_DATA_MASK 0xc0

#define SPI_RPC_DEVICE_GH3 1
#define SPI_RPC_DEVICE_RB 2


void spi_rpc_write(U8 c);
void spi_rpc_init(U8 asHost);
void spi_rpc_disable();
void spi_write_block(U8 c);
U8 spi_read_block();

void Main_notify_spi_rpc_complete(U8 msgSz, U8 * msg);

void spi_rpc_set_device(U8 device);
void spi_rpc_write_report(U8 sz, U8 * dta);
