#ifndef __host_dev_ctrl_h__
#define __host_dev_ctrl_h__

  #define DEVICE_UNATTACHED        0
   #define DEVICE_ATTACHED          1
   #define DEVICE_POWERED           2
   #define DEVICE_DEFAULT           3
   #define DEVICE_ADDRESSED         4
   #define DEVICE_CONFIGURED        5
   #define DEVICE_READY             6

   #define DEVICE_ERROR             7

   #define DEVICE_SUSPENDED         8
   #define DEVICE_WAIT_RESUME       9

   #define DEVICE_DISCONNECTED      10
   #define DEVICE_DISCONNECTED_ACK  11

#define MAX_SUPPORTED_HOST_EP 2

typedef struct S_Host_usb_devicep
{
    U8 device_state;
    U8 device_addr;
    U8 ctrl_pipe_nb;
    U8 ep_pipes[MAX_SUPPORTED_HOST_EP];
    U8 bDeviceClass;
//    U8 hub_device_nb;
    void * misc;
    void(*connectReset)(struct S_Host_usb_devicep * dev);
    void(*handle_state_unattached)(void);
    U8(*handle_state_attached)(struct S_Host_usb_devicep * dev);
    struct S_Host_usb_devicep * next;
} S_Host_usb_device;

extern S_Host_usb_device Host_main_device;
extern volatile U8 private_sof_counter;
extern volatile U16 g_usb_event;

void usb_host_drv_init();
void usb_host_drv_task(S_Host_usb_device* devstruct);

void Host_device_enumerated_action(S_Host_usb_device * devp);

char host_configure_endpoint(S_usb_endpoint_descriptor * ep_desc, char pipe_nb);


// shall return true if supported
char Host_notify_new_device(S_usb_device_descriptor * devdesc,S_Host_usb_device*devstruct);
// shall configure endpoints if supported and return config_nb
// must call host_configure_endpoint
// shall return <0 on error
signed char Host_notify_new_configuration(S_usb_configuration_descriptor * confdesc,S_Host_usb_device*devstruct);


U8 usb_host_hub_enumerated_action(S_Host_usb_device * hubdev);
void Host_device_disconnection_action(S_Host_usb_device * hubdev);
void Host_device_connection_action();
void Host_sof_action(); // runs every ms
void Host_hwup_action();
void Host_device_error_action(S_Host_usb_device * hubdev);


#endif
